/* auto-generated by genmsg_cpp from /opt/ros/boxturtle/stacks/image_pipeline/stereo_msgs/msg/DisparityImage.msg.  Do not edit! */
#ifndef STEREO_MSGS_DISPARITYIMAGE_H
#define STEREO_MSGS_DISPARITYIMAGE_H

#include <string>
#include <vector>
#include "ros/message.h"
#include "ros/debug.h"
#include "ros/assert.h"
#include "ros/time.h"

#include "roslib/Header.h"
#include "sensor_msgs/Image.h"
#include "sensor_msgs/RegionOfInterest.h"

namespace stereo_msgs
{

//! \htmlinclude DisparityImage.msg.html

class DisparityImage : public ros::Message
{
public:
  typedef boost::shared_ptr<DisparityImage> Ptr;
  typedef boost::shared_ptr<DisparityImage const> ConstPtr;

  typedef roslib::Header _header_type;
  typedef sensor_msgs::Image _image_type;
  typedef float _f_type;
  typedef float _T_type;
  typedef sensor_msgs::RegionOfInterest _valid_window_type;
  typedef float _min_disparity_type;
  typedef float _max_disparity_type;
  typedef float _delta_d_type;

  roslib::Header header;
  sensor_msgs::Image image;
  float f;
  float T;
  sensor_msgs::RegionOfInterest valid_window;
  float min_disparity;
  float max_disparity;
  float delta_d;

  DisparityImage() : ros::Message(),
    f(0),
    T(0),
    min_disparity(0),
    max_disparity(0),
    delta_d(0)
  {
  }
  DisparityImage(const DisparityImage &copy) : ros::Message(),
    header(copy.header),
    image(copy.image),
    f(copy.f),
    T(copy.T),
    valid_window(copy.valid_window),
    min_disparity(copy.min_disparity),
    max_disparity(copy.max_disparity),
    delta_d(copy.delta_d)
  {
    (void)copy;
  }
  DisparityImage &operator =(const DisparityImage &copy)
  {
    if (this == &copy)
      return *this;
    header = copy.header;
    image = copy.image;
    f = copy.f;
    T = copy.T;
    valid_window = copy.valid_window;
    min_disparity = copy.min_disparity;
    max_disparity = copy.max_disparity;
    delta_d = copy.delta_d;
    return *this;
  }
  virtual ~DisparityImage() 
  {
  }
  inline static std::string __s_getDataType() { return std::string("stereo_msgs/DisparityImage"); }
  inline static std::string __s_getMD5Sum() { return std::string("ecb8a899b9f71fa05aa8f76aa8cb989a"); }
  inline static std::string __s_getMessageDefinition()
  {
    return std::string(
    "# Separate header for compatibility with current TimeSynchronizer.\n"
    "# Likely to be removed in a later release, use image.header instead.\n"
    "Header header\n"
    "\n"
    "# Floating point disparity image. The disparities are pre-adjusted for any\n"
    "# x-offset between the principal points of the two cameras (in the case\n"
    "# that they are verged). That is: d = x_l - x_r - (cx_l - cx_r)\n"
    "sensor_msgs/Image image\n"
    "\n"
    "# Stereo geometry. For disparity d, the depth from the camera is Z = fT/d.\n"
    "float32 f # Focal length, pixels\n"
    "float32 T # Baseline, world units\n"
    "\n"
    "# Subwindow of (potentially) valid disparity values.\n"
    "sensor_msgs/RegionOfInterest valid_window\n"
    "\n"
    "# The range of disparities searched.\n"
    "# In the disparity image, any disparity less than min_disparity is invalid.\n"
    "# The disparity search range defines the horopter, or 3D volume that the\n"
    "# stereo algorithm can \"see\". Points with Z outside of:\n"
    "#     Z_min = fT / max_disparity\n"
    "#     Z_max = fT / min_disparity\n"
    "# could not be found.\n"
    "float32 min_disparity\n"
    "float32 max_disparity\n"
    "\n"
    "# Smallest allowed disparity increment. The smallest achievable depth range\n"
    "# resolution is delta_Z = (Z^2/fT)*delta_d.\n"
    "float32 delta_d\n"
    "\n"
    "================================================================================\n"
    "MSG: roslib/Header\n"
    "# Standard metadata for higher-level stamped data types.\n"
    "# This is generally used to communicate timestamped data \n"
    "# in a particular coordinate frame.\n"
    "# \n"
    "# sequence ID: consecutively increasing ID \n"
    "uint32 seq\n"
    "#Two-integer timestamp that is expressed as:\n"
    "# * stamp.secs: seconds (stamp_secs) since epoch\n"
    "# * stamp.nsecs: nanoseconds since stamp_secs\n"
    "# time-handling sugar is provided by the client library\n"
    "time stamp\n"
    "#Frame this data is associated with\n"
    "# 0: no frame\n"
    "# 1: global frame\n"
    "string frame_id\n"
    "\n"
    "================================================================================\n"
    "MSG: sensor_msgs/Image\n"
    "# This message contains an uncompressed image\n"
    "# (0, 0) is at top-left corner of image\n"
    "#\n"
    "\n"
    "Header header        # Header timestamp should be acquisition time of image\n"
    "                     # Header frame_id should be optical frame of camera\n"
    "                     # origin of frame should be optical center of cameara\n"
    "                     # +x should point to the right in the image\n"
    "                     # +y should point down in the image\n"
    "                     # +z should point into to plane of the image\n"
    "                     # If the frame_id here and the frame_id of the CameraInfo\n"
    "                     # message associated with the image conflict\n"
    "                     # the behavior is undefined\n"
    "\n"
    "uint32 height         # image height, that is, number of rows\n"
    "uint32 width          # image width, that is, number of columns\n"
    "\n"
    "# The legal values for encoding are in file src/image_encodings.cpp\n"
    "# If you want to standardize a new string format, join\n"
    "# ros-users@lists.sourceforge.net and send an email proposing a new encoding.\n"
    "\n"
    "string encoding       # Encoding of pixels -- channel meaning, ordering, size\n"
    "                      # taken from the list of strings in src/image_encodings.cpp\n"
    "\n"
    "uint8 is_bigendian    # is this data bigendian?\n"
    "uint32 step           # Full row length in bytes\n"
    "uint8[] data          # actual matrix data, size is (step * rows)\n"
    "\n"
    "================================================================================\n"
    "MSG: sensor_msgs/RegionOfInterest\n"
    "# This message is used to specify a region of interest within an image\n"
    "#\n"
    "# When used to specify the ROI setting of the camera when the image was taken,\n"
    "# the height and width fields should either match the height and width\n"
    "# fields for the associated image or be zeroes to indicate that the full image\n"
    "# was captured\n"
    "\n"
    "uint32 x_offset  #Leftmost pixel of the ROI (0 if the left edge of the image is included in the ROI)\n"
    "uint32 y_offset  #Topmost pixel of the ROI (0 if the top edge of the image is included in the ROI)\n"
    "uint32 height    #Height of ROI\n"
    "uint32 width     #Width of ROI\n"
    "\n"
    "\n"
    );
  }
  inline virtual const std::string __getDataType() const { return __s_getDataType(); }
  inline virtual const std::string __getMD5Sum() const { return __s_getMD5Sum(); }
  inline virtual const std::string __getMessageDefinition() const { return __s_getMessageDefinition(); }
  inline uint32_t serializationLength() const
  {
    unsigned __l = 0;
    __l += header.serializationLength(); // header
    __l += image.serializationLength(); // image
    __l += 4; // f
    __l += 4; // T
    __l += valid_window.serializationLength(); // valid_window
    __l += 4; // min_disparity
    __l += 4; // max_disparity
    __l += 4; // delta_d
    return __l;
  }
  virtual uint8_t *serialize(uint8_t *write_ptr,
                             uint32_t seq) const
  {
    roslib::Header _ser_header = header;
    bool __reset_seq = (header.seq == 0);
    if (__reset_seq) _ser_header.seq = seq;
    write_ptr = _ser_header.serialize(write_ptr, seq);
    write_ptr = image.serialize(write_ptr, seq);
    SROS_SERIALIZE_PRIMITIVE(write_ptr, f);
    SROS_SERIALIZE_PRIMITIVE(write_ptr, T);
    write_ptr = valid_window.serialize(write_ptr, seq);
    SROS_SERIALIZE_PRIMITIVE(write_ptr, min_disparity);
    SROS_SERIALIZE_PRIMITIVE(write_ptr, max_disparity);
    SROS_SERIALIZE_PRIMITIVE(write_ptr, delta_d);
    return write_ptr;
  }
  virtual uint8_t *deserialize(uint8_t *read_ptr)
  {
    read_ptr = header.deserialize(read_ptr);
    read_ptr = image.deserialize(read_ptr);
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, f);
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, T);
    read_ptr = valid_window.deserialize(read_ptr);
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, min_disparity);
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, max_disparity);
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, delta_d);
    return read_ptr;
  }
};

typedef boost::shared_ptr<DisparityImage> DisparityImagePtr;
typedef boost::shared_ptr<DisparityImage const> DisparityImageConstPtr;


}

#endif
