# autogenerated by genmsg_py from DisparityImage.msg. Do not edit.
import roslib.message
import struct

import roslib.msg
import sensor_msgs.msg

class DisparityImage(roslib.message.Message):
  _md5sum = "ecb8a899b9f71fa05aa8f76aa8cb989a"
  _type = "stereo_msgs/DisparityImage"
  _has_header = True #flag to mark the presence of a Header object
  _full_text = """# Separate header for compatibility with current TimeSynchronizer.
# Likely to be removed in a later release, use image.header instead.
Header header

# Floating point disparity image. The disparities are pre-adjusted for any
# x-offset between the principal points of the two cameras (in the case
# that they are verged). That is: d = x_l - x_r - (cx_l - cx_r)
sensor_msgs/Image image

# Stereo geometry. For disparity d, the depth from the camera is Z = fT/d.
float32 f # Focal length, pixels
float32 T # Baseline, world units

# Subwindow of (potentially) valid disparity values.
sensor_msgs/RegionOfInterest valid_window

# The range of disparities searched.
# In the disparity image, any disparity less than min_disparity is invalid.
# The disparity search range defines the horopter, or 3D volume that the
# stereo algorithm can "see". Points with Z outside of:
#     Z_min = fT / max_disparity
#     Z_max = fT / min_disparity
# could not be found.
float32 min_disparity
float32 max_disparity

# Smallest allowed disparity increment. The smallest achievable depth range
# resolution is delta_Z = (Z^2/fT)*delta_d.
float32 delta_d

================================================================================
MSG: roslib/Header
# Standard metadata for higher-level stamped data types.
# This is generally used to communicate timestamped data 
# in a particular coordinate frame.
# 
# sequence ID: consecutively increasing ID 
uint32 seq
#Two-integer timestamp that is expressed as:
# * stamp.secs: seconds (stamp_secs) since epoch
# * stamp.nsecs: nanoseconds since stamp_secs
# time-handling sugar is provided by the client library
time stamp
#Frame this data is associated with
# 0: no frame
# 1: global frame
string frame_id

================================================================================
MSG: sensor_msgs/Image
# This message contains an uncompressed image
# (0, 0) is at top-left corner of image
#

Header header        # Header timestamp should be acquisition time of image
                     # Header frame_id should be optical frame of camera
                     # origin of frame should be optical center of cameara
                     # +x should point to the right in the image
                     # +y should point down in the image
                     # +z should point into to plane of the image
                     # If the frame_id here and the frame_id of the CameraInfo
                     # message associated with the image conflict
                     # the behavior is undefined

uint32 height         # image height, that is, number of rows
uint32 width          # image width, that is, number of columns

# The legal values for encoding are in file src/image_encodings.cpp
# If you want to standardize a new string format, join
# ros-users@lists.sourceforge.net and send an email proposing a new encoding.

string encoding       # Encoding of pixels -- channel meaning, ordering, size
                      # taken from the list of strings in src/image_encodings.cpp

uint8 is_bigendian    # is this data bigendian?
uint32 step           # Full row length in bytes
uint8[] data          # actual matrix data, size is (step * rows)

================================================================================
MSG: sensor_msgs/RegionOfInterest
# This message is used to specify a region of interest within an image
#
# When used to specify the ROI setting of the camera when the image was taken,
# the height and width fields should either match the height and width
# fields for the associated image or be zeroes to indicate that the full image
# was captured

uint32 x_offset  #Leftmost pixel of the ROI (0 if the left edge of the image is included in the ROI)
uint32 y_offset  #Topmost pixel of the ROI (0 if the top edge of the image is included in the ROI)
uint32 height    #Height of ROI
uint32 width     #Width of ROI

"""
  __slots__ = ['header','image','f','T','valid_window','min_disparity','max_disparity','delta_d']
  _slot_types = ['Header','sensor_msgs/Image','float32','float32','sensor_msgs/RegionOfInterest','float32','float32','float32']

  ## Constructor. Any message fields that are implicitly/explicitly
  ## set to None will be assigned a default value. The recommend
  ## use is keyword arguments as this is more robust to future message
  ## changes.  You cannot mix in-order arguments and keyword arguments.
  ##
  ## The available fields are:
  ##   header,image,f,T,valid_window,min_disparity,max_disparity,delta_d
  ##
  ## @param self: self
  ## @param args: complete set of field values, in .msg order
  ## @param kwds: use keyword arguments corresponding to message field names
  ## to set specific fields. 
  def __init__(self, *args, **kwds):
    if args or kwds:
      super(DisparityImage, self).__init__(*args, **kwds)
      #message fields cannot be None, assign default values for those that are
      if self.header is None:
        self.header = roslib.msg._Header.Header()
      if self.image is None:
        self.image = sensor_msgs.msg.Image()
      if self.f is None:
        self.f = 0.
      if self.T is None:
        self.T = 0.
      if self.valid_window is None:
        self.valid_window = sensor_msgs.msg.RegionOfInterest()
      if self.min_disparity is None:
        self.min_disparity = 0.
      if self.max_disparity is None:
        self.max_disparity = 0.
      if self.delta_d is None:
        self.delta_d = 0.
    else:
      self.header = roslib.msg._Header.Header()
      self.image = sensor_msgs.msg.Image()
      self.f = 0.
      self.T = 0.
      self.valid_window = sensor_msgs.msg.RegionOfInterest()
      self.min_disparity = 0.
      self.max_disparity = 0.
      self.delta_d = 0.

  ## internal API method
  def _get_types(self): return self._slot_types

  ## serialize message into buffer
  ## @param buff StringIO: buffer
  def serialize(self, buff):
    try:
      buff.write(struct.pack('<3I', self.header.seq, self.header.stamp.secs, self.header.stamp.nsecs))
      length = len(self.header.frame_id)
      #serialize self.header.frame_id
      buff.write(struct.pack('<I%ss'%length, length, self.header.frame_id))
      buff.write(struct.pack('<3I', self.image.header.seq, self.image.header.stamp.secs, self.image.header.stamp.nsecs))
      length = len(self.image.header.frame_id)
      #serialize self.image.header.frame_id
      buff.write(struct.pack('<I%ss'%length, length, self.image.header.frame_id))
      buff.write(struct.pack('<2I', self.image.height, self.image.width))
      length = len(self.image.encoding)
      #serialize self.image.encoding
      buff.write(struct.pack('<I%ss'%length, length, self.image.encoding))
      buff.write(struct.pack('<BI', self.image.is_bigendian, self.image.step))
      length = len(self.image.data)
      #serialize self.image.data
      # - if encoded as a list instead, serialize as bytes instead of string
      if type(self.image.data) in [list, tuple]:
        buff.write(struct.pack('<I%sB'%length, length, *self.image.data))
      else:
        buff.write(struct.pack('<I%ss'%length, length, self.image.data))
      buff.write(struct.pack('<2f4I3f', self.f, self.T, self.valid_window.x_offset, self.valid_window.y_offset, self.valid_window.height, self.valid_window.width, self.min_disparity, self.max_disparity, self.delta_d))
    except struct.error, se: self._check_types(se)
    except TypeError, te: self._check_types(te)

  ## unpack serialized message in str into this message instance
  ## @param self: self
  ## @param str str: byte array of serialized message
  def deserialize(self, str):
    try:
      if self.header is None:
        self.header = roslib.msg._Header.Header()
      if self.image is None:
        self.image = sensor_msgs.msg.Image()
      if self.valid_window is None:
        self.valid_window = sensor_msgs.msg.RegionOfInterest()
      end = 0
      start = end
      end += 12
      (self.header.seq, self.header.stamp.secs, self.header.stamp.nsecs,) = struct.unpack('<3I',str[start:end])
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      #deserialize self.header.frame_id
      pattern = '<%ss'%length
      start = end
      end += struct.calcsize(pattern)
      (self.header.frame_id,) = struct.unpack(pattern, str[start:end])
      start = end
      end += 12
      (self.image.header.seq, self.image.header.stamp.secs, self.image.header.stamp.nsecs,) = struct.unpack('<3I',str[start:end])
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      #deserialize self.image.header.frame_id
      pattern = '<%ss'%length
      start = end
      end += struct.calcsize(pattern)
      (self.image.header.frame_id,) = struct.unpack(pattern, str[start:end])
      start = end
      end += 8
      (self.image.height, self.image.width,) = struct.unpack('<2I',str[start:end])
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      #deserialize self.image.encoding
      pattern = '<%ss'%length
      start = end
      end += struct.calcsize(pattern)
      (self.image.encoding,) = struct.unpack(pattern, str[start:end])
      start = end
      end += 5
      (self.image.is_bigendian, self.image.step,) = struct.unpack('<BI',str[start:end])
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      #deserialize self.image.data
      pattern = '<%ss'%length
      start = end
      end += struct.calcsize(pattern)
      (self.image.data,) = struct.unpack(pattern, str[start:end])
      start = end
      end += 36
      (self.f, self.T, self.valid_window.x_offset, self.valid_window.y_offset, self.valid_window.height, self.valid_window.width, self.min_disparity, self.max_disparity, self.delta_d,) = struct.unpack('<2f4I3f',str[start:end])
      return self
    except struct.error, e:
      raise roslib.message.DeserializationError(e) #most likely buffer underfill


  ## serialize message with numpy array types into buffer
  ## @param self: self
  ## @param buff StringIO: buffer
  ## @param numpy module: numpy python module
  def serialize_numpy(self, buff, numpy):
    try:
      buff.write(struct.pack('<3I', self.header.seq, self.header.stamp.secs, self.header.stamp.nsecs))
      length = len(self.header.frame_id)
      #serialize self.header.frame_id
      buff.write(struct.pack('<I%ss'%length, length, self.header.frame_id))
      buff.write(struct.pack('<3I', self.image.header.seq, self.image.header.stamp.secs, self.image.header.stamp.nsecs))
      length = len(self.image.header.frame_id)
      #serialize self.image.header.frame_id
      buff.write(struct.pack('<I%ss'%length, length, self.image.header.frame_id))
      buff.write(struct.pack('<2I', self.image.height, self.image.width))
      length = len(self.image.encoding)
      #serialize self.image.encoding
      buff.write(struct.pack('<I%ss'%length, length, self.image.encoding))
      buff.write(struct.pack('<BI', self.image.is_bigendian, self.image.step))
      length = len(self.image.data)
      #serialize self.image.data
      # - if encoded as a list instead, serialize as bytes instead of string
      if type(self.image.data) in [list, tuple]:
        buff.write(struct.pack('<I%sB'%length, length, *self.image.data))
      else:
        buff.write(struct.pack('<I%ss'%length, length, self.image.data))
      buff.write(struct.pack('<2f4I3f', self.f, self.T, self.valid_window.x_offset, self.valid_window.y_offset, self.valid_window.height, self.valid_window.width, self.min_disparity, self.max_disparity, self.delta_d))
    except struct.error, se: self._check_types(se)
    except TypeError, te: self._check_types(te)

  ## unpack serialized message in str into this message instance using numpy for array types
  ## @param self: self
  ## @param str str: byte array of serialized message
  ## @param numpy module: numpy python module
  def deserialize_numpy(self, str, numpy):
    try:
      if self.header is None:
        self.header = roslib.msg._Header.Header()
      if self.image is None:
        self.image = sensor_msgs.msg.Image()
      if self.valid_window is None:
        self.valid_window = sensor_msgs.msg.RegionOfInterest()
      end = 0
      start = end
      end += 12
      (self.header.seq, self.header.stamp.secs, self.header.stamp.nsecs,) = struct.unpack('<3I',str[start:end])
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      #deserialize self.header.frame_id
      pattern = '<%ss'%length
      start = end
      end += struct.calcsize(pattern)
      (self.header.frame_id,) = struct.unpack(pattern, str[start:end])
      start = end
      end += 12
      (self.image.header.seq, self.image.header.stamp.secs, self.image.header.stamp.nsecs,) = struct.unpack('<3I',str[start:end])
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      #deserialize self.image.header.frame_id
      pattern = '<%ss'%length
      start = end
      end += struct.calcsize(pattern)
      (self.image.header.frame_id,) = struct.unpack(pattern, str[start:end])
      start = end
      end += 8
      (self.image.height, self.image.width,) = struct.unpack('<2I',str[start:end])
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      #deserialize self.image.encoding
      pattern = '<%ss'%length
      start = end
      end += struct.calcsize(pattern)
      (self.image.encoding,) = struct.unpack(pattern, str[start:end])
      start = end
      end += 5
      (self.image.is_bigendian, self.image.step,) = struct.unpack('<BI',str[start:end])
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      #deserialize self.image.data
      pattern = '<%ss'%length
      start = end
      end += struct.calcsize(pattern)
      (self.image.data,) = struct.unpack(pattern, str[start:end])
      start = end
      end += 36
      (self.f, self.T, self.valid_window.x_offset, self.valid_window.y_offset, self.valid_window.height, self.valid_window.width, self.min_disparity, self.max_disparity, self.delta_d,) = struct.unpack('<2f4I3f',str[start:end])
      return self
    except struct.error, e:
      raise roslib.message.DeserializationError(e) #most likely buffer underfill

